import { shallowMount, mount, createLocalVue, RouterLinkStub } from '@vue/test-utils';
import matchingflowPage from '@/pages/index.vue';
import axios from 'axios';
import moxios from 'moxios';
import flushPromises from 'flush-promises'
import Vue from 'vue'
import Notifications from 'vue-notification'
import frontendStub from '~/components/layouts/frontend.vue'
import stepsStub from '~/components/matchingsteps.vue'
Vue.use(Notifications)
Vue.use(axios)

describe('matchingflow', () => {
    beforeEach(function () {
        // import and pass your custom axios instance to this method
        moxios.install(axios)
        Vue.prototype.$axios = axios
    })

    afterEach(function () {
        // import and pass your custom axios instance to this method
        moxios.uninstall()
    })

    test('test if we see headline', async () => {

        const wrapper = shallowMount(matchingflowPage, {
            Vue,
            stubs: {
                frontendStub,
                stepsStub,
                NuxtLink: RouterLinkStub
            }
        })

        // set axios mock for getting matchingflow response
        let matchingflowResponse = {
            status: 200,
            response:
                [{"_id":1,"name":"Object","headline":"Please specify the Object: ","nextOption":[{"nextOption":[{"_id":"5de21f5338f52064705604a8","name":"Cosntruction Law"},{"_id":"5de21f5338f52064705604a7","name":"Demages Law"},{"_id":"5de21f5338f52064705604a6","name":"Tenancy"}],"_id":"5de21f5338f52064705604a5","name":"Property","headline":"Please select the jurisdictional best fitting your need: "},{"nextOption":[{"_id":"5de21f5338f52064705604a4","name":"Traffic Law"},{"_id":"5de21f5338f52064705604a3","name":"Criminal Law"},{"_id":"5de21f5338f52064705604a2","name":"Demages Law"}],"_id":"5de21f5338f52064705604a1","name":"Vehicle","headline":"Please select the jurisdictional best fitting your need:"},{"nextOption":[{"_id":"5de21f5338f52064705604a0","name":"Demages Law"},{"_id":"5de21f5338f520647056049f","name":"Insurance Law"},{"_id":"5de21f5338f520647056049e","name":"Criminal Law"}],"_id":"5de21f5338f520647056049d","name":"Demages","headline":"Please select the jurisdictional best fitting your need: "}],"__v":0},{"_id":2,"name":"Person","headline":"Specify your relationship to the person: ","nextOption":[{"nextOption":[{"_id":"5de21f5338f52064705604b4","name":"Spouse"},{"_id":"5de21f5338f52064705604b3","name":"Child"},{"_id":"5de21f5338f52064705604b2","name":"Parents"}],"_id":"5de21f5338f52064705604b1","name":"Family","headline":"Specify your relationship to this family member: "},{"nextOption":[{"_id":"5de21f5338f52064705604b0","name":"Demage"},{"_id":"5de21f5338f52064705604af","name":"Misdemeanor"},{"_id":"5de21f5338f52064705604ae","name":"Criminal Offense"}],"_id":"5de21f5338f52064705604ad","name":"Myself","headline":"Please select the case that best fits your needs: "},{"nextOption":[{"_id":"5de21f5338f52064705604ac","name":"Demage"},{"_id":"5de21f5338f52064705604ab","name":"Criminal Offense"},{"_id":"5de21f5338f52064705604aa","name":"Demage"}],"_id":"5de21f5338f52064705604a9","name":"Third","headline":"Please select the category that best fits your case regarding the Third Paty: "}],"__v":0},{"_id":3,"name":"Contract","headline":"Please further specify the contract: ","nextOption":[{"nextOption":[{"_id":"5de21f5338f52064705604c0","name":"Contract Law"},{"_id":"5de21f5338f52064705604bf","name":"Termination"},{"_id":"5de21f5338f52064705604be","name":"Tenancy"}],"_id":"5de21f5338f52064705604bd","name":"Rental contract","headline":"Please select the jurisdictional best fitting your need:"},{"nextOption":[{"_id":"5de21f5338f52064705604bc","name":"Contract Law"},{"_id":"5de21f5338f52064705604bb","name":"Commercial Law"},{"_id":"5de21f5338f52064705604ba","name":"Criminal Law"}],"_id":"5de21f5338f52064705604b9","name":"Purchase contract","headline":"Please select the jurisdictional best fitting your need: "},{"nextOption":[{"_id":"5de21f5338f52064705604b8","name":"Contract Law"},{"_id":"5de21f5338f52064705604b7","name":"Employment Law"},{"_id":"5de21f5338f52064705604b6","name":"Criminal Law"}],"_id":"5de21f5338f52064705604b5","name":"Termination","headline":"Please select the jurisdictional best fitting your need: "}],"__v":0},{"_id":4,"name":"Employment","headline":"About which Aspect is your work about ...","nextOption":[{"nextOption":[{"_id":"5de21f5338f52064705604cd","name":"Contract Law"},{"_id":"5de21f5338f52064705604cc","name":"Employment Law"},{"_id":"5de21f5338f52064705604cb","name":"Criminal Law"}],"_id":"5de21f5338f52064705604ca","name":"Employment Contract","headline":"Please select the jurisdictional best fitting your need: "},{"nextOption":[{"_id":"5de21f5338f52064705604c9","name":"Contract Law"},{"_id":"5de21f5338f52064705604c8","name":"Employment Law"},{"_id":"5de21f5338f52064705604c7","name":"Criminal Law"}],"_id":"5de21f5338f52064705604c6","name":"Termination","headline":"Please select the jurisdictional best fitting your need: "},{"nextOption":[{"_id":"5de21f5338f52064705604c5","name":"Contract Law"},{"_id":"5de21f5338f52064705604c4","name":"Employment Law"},{"_id":"5de21f5338f52064705604c3","name":"Insurance Law"},{"_id":"5de21f5338f52064705604c2","name":"Criminal Law"}],"_id":"5de21f5338f52064705604c1","name":"Insurance","headline":"Please select the jurisdictional best fitting your need: "}],"__v":0}]
            ,
        };

        moxios.stubRequest(process.env.BACKEND_API+"/matchingflow", matchingflowResponse);


        // mock categories
        // set axios mock for getting matchingflow response
        let categoriesResponse = {
            status: 200,
            response:
                [{"_id":"5ddfe6e13a342d5cf80a12be","name":"Contract Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12bf","name":"Construction Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c0","name":"Property Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c1","name":"Commercial Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c2","name":"Sales Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c3","name":"Rental Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c4","name":"Demages Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c5","name":"Tax Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c6","name":"Criminal Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c7","name":"Insurance Law","__v":0},{"_id":"5ddfe6e13a342d5cf80a12c8","name":"Traffic Law","__v":0}]
        };

        moxios.stubRequest(process.env.BACKEND_API+"/matchcatecories", categoriesResponse);


        // mock lawyers
        let lawyersResponse = {
            status: 200,
            response:
                [{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2435a","email":"tim.uff@mail.de","password":"password","profileType":0,"name":"Tim Uff","profession":"Construction Law","description":"I help you on your construction side","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2435b","name":"Jil Doe","email":"jidoe@mail.de","phone":"23423423","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24352","email":"hildegard@ra-in.de","password":"password","profileType":0,"name":"Hildergard Reis","profession":"Contract Law","description":"I help you with your Contracts","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24353","name":"Harald Schmidet","email":"test@mail.de","phone":"0151 75737299","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24366","email":"jim@mail.de","password":"password","profileType":0,"name":"Jim Kurt","profession":"Commercial Law","description":"Commerce, your need is covered by me","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24367","name":"Gunter Jauch","email":"gunter@jauch.de","phone":"232432523234","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2435c","email":"harry@trippel.de","password":"password","profileType":0,"name":"Harry Trippel","profession":"Construction Law","description":"Your Lawyer for construction issues and other issues ;)","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2435d","name":"Stefano Quernhorsto","email":"sq@dessdign.com","phone":"010034838434","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24364","email":"jack.nai@mail.de","password":"password","profileType":0,"name":"Jack Nai","profession":"Commercial Law","description":"Commerce is my Business","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24365","name":"Ulrich Hort","email":"uh@mail.de","phone":"234u82734","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2436e","email":"Ute.Frau@ra.de","password":"password","profileType":0,"name":"Ute Frau","profession":"Sales Law","description":"Ute is your lawyer","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2436f","name":"Willie Brem","email":"Willie@mai.de","phone":"2345678","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24378","email":"Yuri@Gong.de","password":"password","profileType":0,"name":"Yuri Gong","profession":"Demages Law","description":"Yuri helps you with your Damages","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24379","name":"Jaques Joh","email":"jj@mail.de","phone":"1345667876532q31","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24382","email":"Sibille@rainmail.de","password":"password","profileType":0,"name":"Sibille Main","profession":"Criminal Law","description":"Sibille is your Criminal Lawyer","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24383","name":"Kom Bari","email":"ko@mail.de","phone":"0236364723","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2438c","email":"udi@ra.de","password":"password","profileType":0,"name":"Udo Inp","profession":"Insurance Law","description":"Udo gets your inssurance rights","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2438d","name":"*Juir Ol","email":"jo@.@mail.de","phone":"749349394","phase":1}],"__v":0},{"views":[18122017,1332234,"2019-12-05T12:21:47.529Z"],"_id":"5de8f635a5e8ef157fc24354","email":"christopher.roeskes@code.berlin","password":"password","profileType":0,"name":"Christopher Roeskes","profession":"Contract Law","description":"Your contracts are my pleasure","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24355","name":"Rudi Hans","email":"random@1112.de","phone":"0152 434584934","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2435e","email":"sq@design.com","password":"password","profileType":0,"name":"Stefan Quernhorst","profession":"Property Law","description":"Your Porpoerty is what I am fighting for","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2435f","name":"Kai Uwe","email":"ku@mail.de","phone":"93983423882834","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24368","email":"Gieselamueler@mail.de","password":"password","profileType":0,"name":"Giesela Mueller","profession":"Commercial Law","description":"In case of commerce issues, contact Giesela","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24369","name":"Yavi Goncales","email":"yg@mail.de","phone":"234643788","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24370","email":"Willian@ra.de","password":"password","profileType":0,"name":"William Willie","profession":"Rental Law","description":"William is Your Rental Lawyer","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24371","name":"Wolfgang Joop","email":"wj@mail.de","phone":"23456876543","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2437a","email":"Jaqueline.law.de","password":"password","profileType":0,"name":"Jaqueline Line","profession":"Demages Law","description":"can i help you?","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2437b","name":"Ursula Vogel","email":"uv@mail.de","phone":"657483920","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24384","email":"Lena@Jaa.de","password":"password","profileType":0,"name":"Lena Jaa","profession":"Criminal Law","description":"Lena is not a criminal","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24385","name":"Rudi Jo","email":"rj@mails.de","phone":"0987236789","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2438e","email":"traffic@andrea.de","password":"password","profileType":0,"name":"Andrea Traffic","profession":"Traffic Law","description":"Traffic: name and job","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2438f","name":"Detlef Mal","email":"dm@mail.de","phone":"09876235678923","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24356","email":"julian.bertsch@code.berlin","password":"password","profileType":0,"name":"Julian Bertsch","profession":"Contract Law","description":"Having a issues with your contracts is not a problem, as long as you contact me.","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24357","name":"Sibille Ernst","email":"es@mail.de","phone":"001030938473","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24360","email":"kai.ulli@web.de","password":"password","profileType":0,"name":"Kai Ulli","profession":"Property Law","description":"Property Lawyer of Trust","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24361","name":"Inge Baum","email":"inge@baum.de","phone":"32243554545","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24374","email":"leo@lawyer.de","password":"password","profileType":0,"name":"Leo Lowe","profession":"Rental Law","description":"Leo Lawyer for Renatal Law","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24375","name":"Kuki Lipp","email":"kl@mail.de","phone":"1345678765432","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2437e","email":"umi.A2@ra.de","password":"password","profileType":0,"name":"Ute Michaela Ins","profession":"Tax Law","description":"Ute helps","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2437f","name":"Paul Brecht","email":"pb@mail.de","phone":"7473892020","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24388","email":"Maria@Mai.de","password":"password","profileType":0,"name":"Maria Mai","profession":"Insurance Law","description":"Maria Helps everyday","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24389","name":"Caro Lin","email":"cali@mail.de","phone":"0982637823","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24392","email":"ole@mail.deee","password":"password","profileType":0,"name":"Ole Hel","profession":"Traffic Law","description":"Ole: contact him for traffic issues","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24393","name":"Last Contact","email":"lc@mail.de","phone":"8734239","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2436a","email":"Sabrina.lech@mail.de","password":"password","profileType":0,"name":"Sabrina Lech","profession":"Sales Law","description":"Sales in My Steckenpferd","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2436b","name":"Huni Brecht","email":"hb@mail.de","phone":"23456523768","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24372","email":"Erich.k@mail.de","password":"password","profileType":0,"name":"Erich Kai","profession":"Rental Law","description":"Erich is not a poet but a lawyer","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24373","name":"Susi Spree","email":"susi@mail.de","phone":"24567","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2437c","email":"UteSchnee@mail.de","password":"password","profileType":0,"name":"Ute Schnee","profession":"Tax Law","description":"Taxes are my Hobby","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2437d","name":"Harald Jo","email":"Harald@jo.de","phone":"5839203","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24386","email":"Greta@Tun.de","password":"password","profileType":0,"name":"Great Tun","profession":"Criminal Law","description":"Greta Helps you","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24387","name":"Maria Mii","email":"mm@mail.de","phone":"02tyui723","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24358","email":"gerad.lawyer@mail.de","password":"password","profileType":0,"name":"Gerad Lawyer","profession":"Construction Law","description":"Your Construction Helper: Gerad","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24359","name":"Klaus Hoppe","email":"hk@mail.de","phone":"01033374727","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24362","email":"aarnold@mail.de","password":"password","profileType":0,"name":"Annika Arnold","profession":"Property Law","description":"I am THE Property Lawyer of Berlin","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24363","name":"Hans Froh","email":"hf@mail.de","phone":"124787987982","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24376","email":"KaiKoffee@mail.de","password":"password","profileType":0,"name":"kk@mail.de","profession":"Demages Law","description":"Kai can Law","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24377","name":"Kilian Koch","email":"kk@web.de","phone":"2345676546543456","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2438a","email":"Carolin@ra.de","password":"password","profileType":0,"name":"Carolin Jii","profession":"Insurance Law","description":"Caro is your lawyer of trust","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2438b","name":"Kiin Kii","email":"kiki@mail.de","phone":"98728923-2","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc2436c","email":"Inge.tee@mail.de","password":"password","profileType":0,"name":"Inge Tee","profession":"Sales Law","description":"Inge helps you","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc2436d","name":"Ute Mann","email":"um@mail.de","phone":"098765432","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24390","email":"Detlef@Kamn.de","password":"password","profileType":0,"name":"Detlef Kemn","profession":"Traffic Law","description":"Detlef helps you with your traffic","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24391","name":"Rim Mong","email":"Ribnh@shd.de","phone":"-92837652323t","phase":1}],"__v":0},{"views":[18122017,1332234],"_id":"5de8f635a5e8ef157fc24380","email":"Udo@ra.de","password":"password","profileType":0,"name":"ude","profession":"Tax Law","description":"","city":"Berlin","contacts":[{"_id":"5de8f635a5e8ef157fc24381","name":"Horst Nuri","email":"hn@mail.de","phone":"0987627890","phase":1}],"__v":0},{"views":[],"_id":"5de8f66406496716bc8fef02","email":"julian.bertsch81@gmail.com","password":"$2b$12$F50i5j99KlxSYzm3L.DD8e7dFTaBg6St.Ya90/1riCcrvzC2Iv01K","profileType":0,"createdAt":"2019-12-05T12:21:56.745Z","contacts":[],"__v":0}]
        };

        moxios.stubRequest(process.env.BACKEND_API+"/find/all", lawyersResponse);

        expect(wrapper.html()).toContain("Lawconnect")

    })

})
